package consume

import (
	"applet/app/e"
	svc2 "applet/app/svc"
	"applet/app/utils"
	"applet/app/utils/logx"
	"applet/consume/md"
	utils1688 "applet/supply/1688/utils"
	"applet/supply/db"
	"applet/supply/db/model"
	"applet/supply/enum"
	md2 "applet/supply/md"
	"applet/supply/svc"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/gin-gonic/gin"
	"github.com/streadway/amqp"
	"time"
)

func SupplyCloudChainFenxiaoNewChangeConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			fmt.Println(">>>>>>>>>>>>>>>>SupplyCloudChainFenxiaoNewChangeConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			//解析mq中queue的数据结构体
			var pushStuct struct {
				Args struct {
					md2.GoodsAddPriceConditions
				} `json:"args"`
				Mid string `json:"mid"`
			}
			err = json.Unmarshal(res.Body, &pushStuct)
			if err != nil {
				panic(err)
			}

			//设置masterId
			var c = &gin.Context{}
			c.Set("mid", pushStuct.Mid)
			var t struct {
				md2.GoodsAddPriceConditions
			}
			t = pushStuct.Args
			var idsMap = map[string]string{}
			for _, v := range t.Ids {
				idsMap[v] = v
			}
			var idsArray []string
			for _, v := range idsMap {
				idsArray = append(idsArray, v)
			}
			t.Ids = idsArray

			basicSetting, _ := svc.GetSupplyBasicSetting(c)
			if basicSetting == nil {
				fmt.Println("!!!!!功能开发中!!!!!")
				return
			}
			if basicSetting.AliCloudChainFenXiaoAppkey == "" || basicSetting.AliCloudChainFenXiaoAppsecret == "" || basicSetting.AliCloudChainFenXiaoAccesstoken == "" {
				fmt.Println("!!!!!必要参数没有填写，功能已暂停!!!!!")
				return
			}
			get, systemMerchant, err1 := db.GetSystemMerchant(svc2.MasterDb(c))
			if err1 != nil {
				fmt.Println(err1.Error(), "!!!!!!!!!!!!!!!!!!!!")
				return
			}
			if !get {
				fmt.Println("!!!!!请先去设置官方商家信息!!!!!")
				return
			}
			ids := RemoveRepeatedElement(t.Ids)
			for _, id := range ids {
				var goods model.MallGoods
				goods.CloudChainGoodsId = id
				goods.MerchantId = systemMerchant.Id
				getV2, err := goods.GetV2(svc2.MasterDb(c))
				if err != nil {
					e.OutErr(c, e.ERR, err.Error())
					return
				}
				if getV2 {
					continue
				}

				goodsFrom1688, err := utils1688.GetFenXiaoProductInfoFrom1688(basicSetting.AliCloudChainFenXiaoAppkey, basicSetting.AliCloudChainFenXiaoAppsecret, basicSetting.AliCloudChainFenXiaoAccesstoken, id)
				if err != nil {
					logx.Error(err)
					continue
				}
				var req md2.AddGoodsReq
				req.Base.GoodsType = 1
				req.Base.CloudChainGoodsId = id
				req.Base.SaleState = enum.MallGoodsSaleStateOnShelf
				req.Base.CategoryId = utils.StrToInt(t.CategoryId)
				req.Base.MerchantId = systemMerchant.Id
				result, ok := goodsFrom1688["result"].(map[string]interface{})
				if !ok {
					e.OutErr(c, e.ERR, logx.Error("错误的数据").Error())
					return
				}
				if message, ok := result["message"]; ok {
					e.OutErr(c, e.ERR, message)
					return
				}
				resultList, ok := result["result"].([]interface{})
				if !ok {
					e.OutErr(c, e.ERR, logx.Error("错误的数据2").Error())
					return
				}
				if len(resultList) == 0 {
					e.OutErr(c, e.ERR, logx.Error("错误的数据3").Error())
					return
				}
				cloudChainGoods, ok := resultList[0].(map[string]interface{})
				if !ok {
					e.OutErr(c, e.ERR, logx.Error("错误的数据4").Error())
					return
				}
				utils.FilePutContents("cloudChainGoods", utils.SerializeStr(cloudChainGoods))
				err = svc.CloudChainFenXiaoGoodsChangeMallGoods(c, cloudChainGoods, &req)
				if err != nil {
					switch err.(type) {
					case e.E:
						err1 := err.(e.E)
						e.OutErr(c, err1.Code, err1.Error())
						return
					default:
						e.OutErr(c, e.ERR, err.Error())
						return
					}
				}

				err1 := svc.AddMallGoods(c, &req)
				if err1 != nil {
					switch err1.(type) {
					case e.E:
						err1 := err1.(e.E)
						e.OutErr(c, err1.Code, err1.Error())
						return
					default:
						e.OutErr(c, e.ERR, err1.Error())
						return
					}
				}

				time.Sleep(10 * time.Millisecond)
			}

			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func RemoveRepeatedElement(arr []string) (newArr []string) {
	newArr = make([]string, 0)
	for i := 0; i < len(arr); i++ {
		repeat := false
		for j := i + 1; j < len(arr); j++ {
			if arr[i] == arr[j] {
				repeat = true
				break
			}
		}
		if !repeat {
			newArr = append(newArr, arr[i])
		}
	}
	return
}
